/// @cond EO_CXX_EO_IMPL

inline ::elm_app_server::_c_constructor elm_app_server::constructor(::efl::eina::string_view packageid_, Elm_App_Server_Create_View_Cb create_view_cb_)
{
   return _c_constructor(packageid_, create_view_cb_);
}

inline void elm_app_server::close_all() const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_server_close_all());
}

inline bool elm_app_server::view_check(::efl::eina::string_view id_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_server_view_check(::efl::eolian::to_c(id_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm_app_server::view_add(::elm_app_server_view view_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_server_view_add(::efl::eolian::to_c(view_)));
}

inline void elm_app_server::title_set(::efl::eina::optional< ::efl::eina::string_view > title_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_server_title_set(::efl::eolian::to_c(title_)));
}

inline Eina_Stringshare * elm_app_server::title_get() const
{
   Eina_Stringshare * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_server_title_get());
   return _tmp_ret;
}

inline void elm_app_server::save() const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_server_save());
}

inline Eina_Stringshare * elm_app_server::icon_get() const
{
   Eina_Stringshare * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_server_icon_get());
   return _tmp_ret;
}

inline void elm_app_server::icon_set(Eina_Stringshare * icon_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_server_icon_set(icon_));
}

inline Eina_Iterator * elm_app_server::views_get() const
{
   Eina_Iterator * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_server_views_get());
   return _tmp_ret;
}

inline ::efl::eina::string_view elm_app_server::path_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_server_path_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline Eina_Stringshare * elm_app_server::package_get() const
{
   Eina_Stringshare * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_server_package_get());
   return _tmp_ret;
}

inline void elm_app_server::pixels_get(unsigned int* w_, unsigned int* h_, Eina_Bool* has_alpha_, const unsigned char ** pixels_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_server_pixels_get(w_, h_, has_alpha_, pixels_));
}

inline void elm_app_server::pixels_set(unsigned int w_, unsigned int h_, bool has_alpha_, const unsigned char * pixels_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_server_pixels_set(w_, h_, ::efl::eolian::to_c(has_alpha_), pixels_));
}

inline void eo_cxx::elm_app_server::close_all() const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_server_close_all());
}

inline bool eo_cxx::elm_app_server::view_check(::efl::eina::string_view id_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_server_view_check(::efl::eolian::to_c(id_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm_app_server::view_add(::elm_app_server_view view_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_server_view_add(::efl::eolian::to_c(view_)));
}

inline void eo_cxx::elm_app_server::title_set(::efl::eina::optional< ::efl::eina::string_view > title_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_server_title_set(::efl::eolian::to_c(title_)));
}

inline Eina_Stringshare * eo_cxx::elm_app_server::title_get() const
{
   Eina_Stringshare * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_server_title_get());
   return _tmp_ret;
}

inline void eo_cxx::elm_app_server::save() const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_server_save());
}

inline Eina_Stringshare * eo_cxx::elm_app_server::icon_get() const
{
   Eina_Stringshare * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_server_icon_get());
   return _tmp_ret;
}

inline void eo_cxx::elm_app_server::icon_set(Eina_Stringshare * icon_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_server_icon_set(icon_));
}

inline Eina_Iterator * eo_cxx::elm_app_server::views_get() const
{
   Eina_Iterator * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_server_views_get());
   return _tmp_ret;
}

inline ::efl::eina::string_view eo_cxx::elm_app_server::path_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_server_path_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline Eina_Stringshare * eo_cxx::elm_app_server::package_get() const
{
   Eina_Stringshare * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_server_package_get());
   return _tmp_ret;
}

inline void eo_cxx::elm_app_server::pixels_get(unsigned int* w_, unsigned int* h_, Eina_Bool* has_alpha_, const unsigned char ** pixels_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_server_pixels_get(w_, h_, has_alpha_, pixels_));
}

inline void eo_cxx::elm_app_server::pixels_set(unsigned int w_, unsigned int h_, bool has_alpha_, const unsigned char * pixels_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_server_pixels_set(w_, h_, ::efl::eolian::to_c(has_alpha_), pixels_));
}

inline ::eo_cxx::elm_app_server::operator ::elm_app_server() const
{
   return *static_cast<::elm_app_server const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm_app_server::operator ::elm_app_server&()
{
   return *static_cast<::elm_app_server*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm_app_server::operator ::elm_app_server const&() const
{
   return *static_cast<::elm_app_server const*>(static_cast<void const*>(this));
}

template <typename T>
void _elm_app_server_close_all_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->close_all();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _elm_app_server_view_check_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * id_)
{
   try
      {
         return static_cast<T*>(self->this_)->view_check(::efl::eolian::to_cxx<::efl::eina::string_view>(id_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void _elm_app_server_view_add_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_App_Server_View * view_)
{
   try
      {
         static_cast<T*>(self->this_)->view_add(::efl::eolian::to_cxx<::elm_app_server_view>(view_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _elm_app_server_title_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * title_)
{
   try
      {
         static_cast<T*>(self->this_)->title_set(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(title_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Eina_Stringshare * _elm_app_server_title_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->title_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Stringshare * _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void _elm_app_server_save_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->save();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Eina_Stringshare * _elm_app_server_icon_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->icon_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Stringshare * _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void _elm_app_server_icon_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Stringshare * icon_)
{
   try
      {
         static_cast<T*>(self->this_)->icon_set(icon_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Eina_Iterator * _elm_app_server_views_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->views_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Iterator * _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
::efl::eina::string_view _elm_app_server_path_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->path_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
Eina_Stringshare * _elm_app_server_package_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->package_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Stringshare * _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void _elm_app_server_pixels_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, unsigned int* w_, unsigned int* h_, Eina_Bool* has_alpha_, const unsigned char ** pixels_)
{
   try
      {
         static_cast<T*>(self->this_)->pixels_get(w_, h_, has_alpha_, pixels_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _elm_app_server_pixels_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, unsigned int w_, unsigned int h_, Eina_Bool has_alpha_, const unsigned char * pixels_)
{
   try
      {
         static_cast<T*>(self->this_)->pixels_set(w_, h_, ::efl::eolian::to_cxx<bool>(has_alpha_, std::tuple<std::false_type>()), pixels_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_app_server >
{
   template <typename T>
   struct type
         : virtual operations< ::eo::base >::template type<T>
   {
      virtual void close_all()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_app_server_close_all());
      }

      virtual bool view_check(::efl::eina::string_view id_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_server_view_check(::efl::eolian::to_c(id_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void view_add(::elm_app_server_view view_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_app_server_view_add(::efl::eolian::to_c(view_)));
      }

      virtual void title_set(::efl::eina::optional< ::efl::eina::string_view > title_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_app_server_title_set(::efl::eolian::to_c(title_)));
      }

      virtual Eina_Stringshare * title_get()
      {
         Eina_Stringshare * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_server_title_get());
            return _tmp_ret;
      }

      virtual void save()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_app_server_save());
      }

      virtual Eina_Stringshare * icon_get()
      {
         Eina_Stringshare * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_server_icon_get());
            return _tmp_ret;
      }

      virtual void icon_set(Eina_Stringshare * icon_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_app_server_icon_set(icon_));
      }

      virtual Eina_Iterator * views_get()
      {
         Eina_Iterator * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_server_views_get());
            return _tmp_ret;
      }

      virtual ::efl::eina::string_view path_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_server_path_get());
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Eina_Stringshare * package_get()
      {
         Eina_Stringshare * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_server_package_get());
            return _tmp_ret;
      }

      virtual void pixels_get(unsigned int* w_, unsigned int* h_, Eina_Bool* has_alpha_, const unsigned char ** pixels_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_app_server_pixels_get(w_, h_, has_alpha_, pixels_));
      }

      virtual void pixels_set(unsigned int w_, unsigned int h_, bool has_alpha_, const unsigned char * pixels_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_app_server_pixels_set(w_, h_, ::efl::eolian::to_c(has_alpha_), pixels_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_app_server >
{
   static constexpr int value = 
#if defined(ELM_APP_SERVER_PROTECTED) && defined(ELM_APP_SERVER_BETA)
      13
#elif defined(ELM_APP_SERVER_PROTECTED)
      13
#elif defined(ELM_APP_SERVER_BETA)
      13
#else
      13
#endif
      + operation_description_class_size<::eo::base >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm_app_server>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_server_close_all_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_server_close_all);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_server_view_check_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_check);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_server_view_add_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_add);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_server_title_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_server_title_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_server_title_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_server_title_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_server_save_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_server_save);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_server_icon_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_server_icon_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_server_icon_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_server_icon_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_server_views_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_server_views_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_server_path_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_server_path_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_server_package_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_server_package_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_server_pixels_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_server_pixels_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_server_pixels_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_server_pixels_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::eo::base>(), &ops[operation_description_class_size< ::elm_app_server >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm_app_server>)
{
   return (ELM_APP_SERVER_CLASS);
}

} } }

/// @endcond

